var _excluded = ["barAttribute", "captionAttribute", "percentage", "max", "min", "value", "showPercentage", "children"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Counter from './../Counter';

var Progress = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Progress, _Component);

  function Progress(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "componentDidMount", function () {});

    return _this;
  }

  var _proto = Progress.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        _this$props$barAttrib = _this$props.barAttribute,
        barAttribute = _this$props$barAttrib === void 0 ? {} : _this$props$barAttrib,
        _this$props$captionAt = _this$props.captionAttribute,
        captionAttribute = _this$props$captionAt === void 0 ? {} : _this$props$captionAt,
        percentage = _this$props.percentage,
        max = _this$props.max,
        min = _this$props.min,
        value = _this$props.value,
        showPercentage = _this$props.showPercentage,
        children = _this$props.children,
        others = _objectWithoutPropertiesLoose(_this$props, _excluded); // 计算百分比


    var barPercentage = 0;
    var textPercentage = 0;

    if (!isNaN(percentage)) {
      barPercentage = textPercentage = percentage;
    } else if (!isNaN(max) && !isNaN(value)) {
      barPercentage = textPercentage = value / (max - min) * 100;
    }

    if (barPercentage > 100) {
      barPercentage = 100;
    } else if (barPercentage < 0) {
      barPercentage = 0;
    }

    return /*#__PURE__*/React.createElement("div", _extends({}, others, {
      className: "progress" + (others.className ? ' ' + others.className : ''),
      style: style
    }), /*#__PURE__*/React.createElement("span", _extends({
      ref: function ref(el) {
        _this2.$bar = el;
      }
    }, barAttribute, {
      className: "progress-bar" + (barAttribute.className ? ' ' + barAttribute.className : ''),
      style: Object.assign({}, barAttribute.style || {}, {
        width: barPercentage + '%'
      })
    }), showPercentage && /*#__PURE__*/React.createElement(Counter, _extends({}, captionAttribute, {
      className: "progress-caption" + (captionAttribute.className ? ' ' + captionAttribute.className : ''),
      duration: 1000,
      to: textPercentage,
      from: 0,
      suffix: '%'
    })), !showPercentage && /*#__PURE__*/React.createElement(Counter, _extends({}, captionAttribute, {
      className: "progress-caption" + (captionAttribute.className ? ' ' + captionAttribute.className : ''),
      duration: 1000,
      to: Number(value),
      from: min,
      suffix: '/' + max
    }))), children);
  };

  return Progress;
}(Component);

_defineProperty(Progress, "defaultProps", {
  showPercentage: true,
  max: 100,
  min: 0,
  value: 0
});

export { Progress as default };
Progress.propTypes = process.env.NODE_ENV !== "production" ? {
  barAttribute: PropTypes.object,
  captionAttribute: PropTypes.object,
  percentage: PropTypes.number,
  max: PropTypes.number,
  min: PropTypes.number,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  showPercentage: PropTypes.bool,
  children: PropTypes.node
} : {};